<?php
/*
~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
~= YapGB - Yet Another Php Guest Book                              =~
~= v0.5.1                                                          =~
~= Nov 7th, 2004                                                   =~
~= http://www.hewop.com/~yapgb                                     =~
~= yapgb@hewop.com                                                 =~
~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
~= AUTHOR:                                                         =~
~=    Jos Jorge Enrquez Rodrguez                                =~
~=    geo@geosoft.tk (redirected email)                            =~
~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
~= YapGB is a free guestbook system written in PHP that does not   =~
~= require a database, entries are stored in a plain text file.    =~
~= Copyright (C) 2003-2004 Jos Jorge Enrquez Rodrguez           =~
~=                                                                 =~
~= This program is free software; you can redistribute it and/or   =~
~= modify it under the terms of the GNU General Public License     =~
~= as published by the Free Software Foundation; either version 2  =~
~= of the License, or (at your option) any later version.          =~
~=                                                                 =~
~= This program is distributed in the hope that it will be useful, =~
~= but WITHOUT ANY WARRANTY; without even the implied warranty of  =~
~= MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   =~
~= GNU General Public License for more details.                    =~
~=                                                                 =~
~= You should have received a copy of the GNU General Public       =~
~= License along with this program; if not, write to the Free      =~
~= Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, =~
~= MA  02111-1307, USA                                             =~
~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
~= CHANGES                                                         =~
~= v0.5:                                                           =~
~= - Added configuration variables for enabling/disabling BBCode   =~
~=   and smilies.                                                  =~
~= - Changed $gbAllowedTags to $gbAllowedHTMLTags, but GB_TAG      =~
=    keeps the same: GB_ALLOWEDTAGS for compatibility.             =~
~= v0.4.2:                                                         =~
~= - Added configuration variables for customizing guestbook's     =~
~=   timezone and for notifying administrator of new entries.      =~
~=   There are five new configuration variables: $gbNewPostNotify, =~
~=   $gbNotifyTo, $gbNotifyFrom, $gbNotifyText and $gbGMTOffset.   =~
~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
*/

# This is used so that nobody can see the contents of this file.
# You should change yapgb.php to whatever page you want to
# redirect the user when trying to access this file.
if ( eregi("config.php", $_SERVER["PHP_SELF"]) ) {
  header("location: yapgb.php");
  exit();
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
# YapGB configuration variables #
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#

# $gbFile,
# text file for storing entries.
$gbFile = "entries.txt";

# $gbIndex,
# the name of YapGB main file (yapgb.php in the normal release),
# so you can modify it and use index.php, guestbook.php or
# whatever you like :), just remember to update this variable.
$gbIndex ="yapgb.php";

# $gbTheme
# Theme defining the appearance of YapGB.
$gbTheme = "melody1";

# $gbTitle
# Guestbook's title.
$gbTitle = "YapGB - Yet Another PHP Guest Book";

# $gbLimit
# Entries per page.
$gbLimit = 5;

# $gbAllowedHTMLTags ($gbAllowedTags was substituted by this).
# The list of HTML tags that are allowed in the guest book. No
# closing tags are needed, since they are included automatically.
# I recommend you not to add anything else, but you could delete
# something :). If you want to disable HTML tags, just leave it
# blank, like this:
# $gbAllowedHTMLTags = "";
# In general, HTML tags are not allowed in guest books and message
# boards, it's a matter of security, since someone could use them
# to harm your site (specially using script languages such as
# JavaScript).
$gbAllowedHTMLTags = "<i><o><u>";

# $gbSiteIndex
# Main site's url, it's used by the [Back to site] link.
$gbSiteIndex = "http://localhost/";

# $gbAdminPass
# Administration password, it is used for deleting and modifying
# guest book entries.
$gbAdminPass = "adminpass";

# $gbRequireEmail
# A value of 1 means that the email field is required. 0 means
# it is not required.
$gbRequireEmail = 0;

# $gbRequireUrl
# 1 = an url address is required, 0 = it is not required.
$gbRequireUrl = 0;

# $gbHideEmail
# This option has been added in order to protect your visitors
# against spam bots seeking the Internet for email addresses.
# When it is 0, it will work normally (example@domain.com),
# but when this configuration variable is turned on (that is,
# it has a value of 1), the email addresses will be seen as
# example [at] domain [dot] com.
$gbHideEmail = 1;

# $gbHideEmailAt
# This is the text that replaces the @ in email addresses when
# $gbHideEmail is turned on.
$gbHideEmailAt = " [at] ";

# $gbHideEmailDot
# This will replace the dots (.) in email addresses when
# $gbHideEmail is on.
$gbHideEmailDot = " [dot] ";

#**************
# NOTE about $msgXxxx variables:
# These variables are being used as a first approach to a
# multilingual YapGB interface. However, it is not at the top
# of development of new features, so it may not be implemented
# in the near future (but if so, they won't be included here but
# into a separate folder with several files, each of one will set
# these variables for every language).
# These variables are here to help you customize some messages
# (mainly the error message and Next/Previous page links),
# and/or let you have these messages in your own language.
#**************

# Required field messages
# These are used so that you can edit the messages that are shown
# when the user did not enter the required information.
# You can use HTML code within the text of this variables, so you could
# for example have a message in red by using the <font> tag:
# Important note: if you want to use quotes within your HTML
# tags, please use single quotes (') or add a back-slash before any
# quotes you'll use (this is a PHP feature). You have several options,
# let's say you'd like to show the ERROR message in red, you could
# use one of these:
# $msgError = "<font color=red>ERROR</font>";
# $msgError = "<font color='red'>ERROR</font>";
# $msgError = "<font color=\"red\">ERROR</font>";
# Note the use of back-slashes in last option, they are needed in
# PHP code, but they will work fine in the resulting HTML page.
$msgError = "ERROR";
$msgNameRequired = "You forgot to write your name! Please go back and try again.";
$msgMessageRequired = "You forgot to write your message! Please go back and try again.";
$msgEmailRequired = "An email address is required. Please go back and try again.";
$msgUrlRequired = "An url address is required. Please go back and try again.";
$msgEmailIncorrect = "The email address is not valid. Please go back and correct it.";
$msgUrlIncorrect = "The url address is not valid. Please go back and correct it.";

# $msgNext and $msgPrev
# These variables hold the text for the Next and Previous page links.
$msgNext = "[NEXT]";
$msgPrev = "[PREV]";

# $gbBadWords
# Array containing censored words.
# NOTE: at this moment these words are stored in the entries file
# without being censored, they are censored just when showing guest
# book entries. This is to prevent data loss if the censoring
# function does not work correctly.
$gbBadWords = array(
  " ass",
  " bitch ",
  " clit",
  " cock ",
  " c0ck ",
  " cum ",
  " cunt ",
  "fucking",
  "fuck",
  "fuking",
  "fuk");

# $gbMaxWordLenght
# Maximum characters per word, if any word is longer than this, then
# that word is "cut" and "..." is added at the end of it to let know
# that the word has been "chopped".
$gbMaxWordLenght = 50;

/** Email notification **/
# If you want to be notified of new entries added to your guestbook,
# set $gbNewPostNotify to 1.
# Note: the mail() function should be available in your server
# (if you are using a free PHP hosting service, the mail() function
# may be disabled in order to avoid spamming)
$gbNewPostNotify = 0;
# $gbNotifyFrom
# The address that will appear as the sender of notification emails.
# It is not required right now and you can leave it unchanged or blank,
# but in a future version it could be of more use.
$gbNotifyFrom = "yourmail@yourdomain.com";
# $gbNotifyTo
# Email address which notifications will be sent to.
$gbNotifyTo = "yourmail@yourdomain.com";
# $gbNotifyTitle
# Notification emails title.
$gbNotifyTitle = "YapGB: new post!";
# gbNotifyText
# If you enable the notify option, the message you receive will be the one
# stored in this variable. You can use GB_TAGS within to help you customize
# the message you receive :). The GB_TAGS you can use are:
# - All global GB_TAGS (used in temp_body.html file).
# - Entry GB_TAGS <!--GB_ENTRYNAME-->, <!--GB_ENTRYEMAIL-->,
#   <!--GB_ENTRYURL--> and <!--GB_ENTRYMESSAGE-->.
# Note: if you want to use double quotes (") within this text, you should write
#       them this way: \" (using the back-slash). This is a PHP requirement.
$gbNotifyText = "<!--GB_ENTRYNAME--> has signed your guestbook at http://www.yoursite.com/yapgb.php\n"
                ."Email: <!--GB_ENTRYEMAIL-->.\n"
                ."Url: <!--GB_ENTRYURL-->\n";

# $gbGMTOffset
# System timezone, you can use it to customize YapGB timezone.
# Time is got from server's time, but now it is formatted
# in GMT format, so you can customize it by adding or substracting
# your GMT time offset.
# For example, if you live in
$gbGMTOffset = -5;

# gbEnableBBCode ** NEW **
# Enable BBCode.
# As with other variables, a 1 enables BBCode and a 0 disables it.
# Note that this function is still experimental and may not work
# properly in some special cases.
$gbEnableBBCode = 1;
# gbEnableSmilies ** NEW **
# Enable smilies. If set to 1, smilies in the message field will be
# swapped by a corresponding image indicated in the $gbSmilies array.
$gbEnableSmilies = 1;
# gbSmiliesPath
# The folder where smilies images are stored.
$gbSmiliesPath = "smilies/";
# $gbSmilies ** NEW **
# The smilies array. Please do not edit it unless you know what you are
# doing ;). This variable makes this file even bigger, sorry :). I'll try
# to implement a better administration interface.
# "smilie" => array("image.ext", "Emotion"),
# If you want to disable a smilie, delete the lines where that smilie
# appears below. Also, you'll want to edit your temp_sign.html file and
# delete the smilie from the signing form.
# Note: the images included with YapGB were "borrowed" from the phpBB forum.
$gbSmilies = array(
    ":!:" => array("icon_exclaim.gif", "Exclamation"),
    ":?:" => array("icon_question.gif", "Question"),
    ":?" => array("icon_confused.gif", "Confused"),
    ":-?" => array("icon_confused.gif", "Confused"),
    ":D" => array("icon_biggrin.gif", "Very happy"),
    ":-D" => array("icon_biggrin.gif", "Very happy"),
    ":grin:" => array("icon_biggrin.gif", "Very happy"),
    ":)" => array("icon_smile.gif", "Smile"),
    ":-)" => array("icon_smile.gif", "Smile"),
    ":smile:" => array("icon_smile.gif", "Smile"),
    ":(" => array("icon_sad.gif", "Sad"),
    ":-(" => array("icon_sad.gif", "Sad"),
    ":sad:" => array("icon_sad.gif", "Sad"),
    ":oops:" => array("icon_redface.gif", "Embarrased"),
    ":o" => array("icon_surprised.gif", "Surprised"),
    ":-o" => array("icon_surprised.gif", "Surprised"),
    ":shock:" => array("icon_eek.gif", "Shocked"),
    "8)" => array("icon_cool.gif", "Cool"),
    "8-)" => array("icon_cool.gif", "Cool"),
    ":lol:" => array("icon_lol.gif", "Laughing"),
    ":x" => array("icon_mad.gif", "Mad"),
    ":-x" => array("icon_mad.gif", "Mad"),
    ":P" => array("icon_razz.gif", "Razz"),
    ":-P" => array("icon_razz.gif", "Razz"),
    ":cry:" => array("icon_cry.gif", "Crying or very sad"),
    ";)" => array("icon_wink.gif", "Winking"),
    ";-)" => array("icon_wink.gif", "Winking"),
    ":wink:" => array("icon_wink.gif", "Winking"),
    ":idea:" => array("icon_idea.gif", "Idea")
);

# $gbInfo
# "Powered by YapGB" message, please do not delete its content.
$gbInfo = "<font style=\"font-family:Arial; font-size:9.5px\">\n"
         ."<b>Powered by <a href=\"http://www.hewop.com/~yapgb\" target=\"_blank\" title=\"YapGB - Yet Another PHP Guest Book\">YapGB v0.5.1</a></b>\n"
         ."</font>\n";
?>