<?php
/*
~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
~= YapGB - Yet Another Php Guest Book                              =~
~= v0.5.1                                                          =~
~= Nov 7th, 2004                                                   =~
~= http://www.hewop.com/~yapgb                                     =~
~= yapgb@hewop.com                                                 =~
~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
~= AUTHOR:                                                         =~
~=    Jos Jorge Enrquez Rodrguez                                =~
~=    geo@geosoft.tk (redirected email)                            =~
~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
~= YapGB is a free guestbook system written in PHP that does not   =~
~= require a database, entries are stored in a plain text file.    =~
~= Copyright (C) 2003-2004 Jos Jorge Enrquez Rodrguez           =~
~=                                                                 =~
~= This program is free software; you can redistribute it and/or   =~
~= modify it under the terms of the GNU General Public License     =~
~= as published by the Free Software Foundation; either version 2  =~
~= of the License, or (at your option) any later version.          =~
~=                                                                 =~
~= This program is distributed in the hope that it will be useful, =~
~= but WITHOUT ANY WARRANTY; without even the implied warranty of  =~
~= MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   =~
~= GNU General Public License for more details.                    =~
~=                                                                 =~
~= You should have received a copy of the GNU General Public       =~
~= License along with this program; if not, write to the Free      =~
~= Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, =~
~= MA  02111-1307, USA                                             =~
~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
~= CHANGES                                                         =~
~= v0.5:                                                           =~
~= - Modified swapSmilies a bit: the smilies array is now located  =~
~=   in config.php.                                                =~
~= - Added a condition to improve the pagination function. Thanks  =~
~=   to Dan Edwards for the correction.                            =~
~= - Function readTemplate now gets only the file name and not the =~
~=   full path as parameter.                                       =~
~= v0.4.2:                                                         =~
~= - Modified swapDateTags() function to work with GMT dates so    =~
~=   that it is possible to customize guestbook's timezone.        =~
~= - Added the include("config.php"); at the beginning of file so  =~
~=   that $gbIndex variable is declared before using it in the     =~
~=   direct access to file checking.                               =~
~= - Added the newPostNotify function for notifying admin of new   =~
~=   entries.                                                      =~
~= - Modified checkEmail() and checkUrl functions, the if-else     =~
~=   instructions were redundant.                                  =~
~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
*/

# Include configuration file.
include ("config.php");

# If trying to access this file directly, redirect
# to main YapGB file.
if ( eregi("func.php", $_SERVER["PHP_SELF"]) ) {
  header("Location: $gbIndex");
  die();
}

# function hideEmail($string)
function hideEmail($string) {
  global $gbHideEmailAt, $gbHideEmailDot;
  $string = str_replace("@", $gbHideEmailAt, $string);
  $string = str_replace(".", $gbHideEmailDot, $string);

  return $string;
}

# function swapBadWords($string)
# This function bans occurrences of words in
# $gbBadWords (in config.php). It keeps first and last
# letters of bad word, replacing inner letters with '*'.
function swapBadWords($string) {
  global $gbBadWords;

  # Number of words to ban
  $nBadWords = sizeof($gbBadWords);

  for ($i = 0; $i < $nBadWords; $i++) {

    # Get first letter of banned word
    $banned = substr($gbBadWords[$i], 0, 1);
    # Replace middle letters of banned word
    for ($j = 1; $j < strlen($gbBadWords[$i]); $j++) {
      $banned .= "*";
    }
    # Add last letter of banned word
    //$banned .= substr($gbBadWords[$i], -1, 1);

    # Replace occurences of banned word with $banned, which
    # contains first and last letters of bad word, with other
    # chars replaced with *.
    $string = str_replace($gbBadWords[$i], $banned, $string);
  }
  return $string;
}

# function cutLongWords($string)
# Searches for every word in $string that is longer than the
# allowed $gbMaxWordLenght.
function cutLongWords($string) {
  global $gbMaxWordLenght;

  // Make sure all break lines are <br> tags.
  // (It will have to be <br /> as stated by XHTML, but
  // I'm keeping <br> for old browsers compatibility.
  $string = str_replace("<br />", "<br>", $string);

  $lines = explode("<br>", $string);

  // For every line
  for ($i = 0; $i < sizeof($lines); $i++) {
    $words = explode(" ", $lines[$i]);
    for ($j = 0; $j < sizeof($words); $j++) {
      if ( strlen($words[$j]) > $gbMaxWordLenght ) {
        $words[$j] = substr($words[$j], 0, $gbMaxWordLenght) . "...";
      }
    }
    $lines[$i] = implode(" ", $words);
  }
  $result = implode("<br>", $lines);

  return $result;
}

# function checkEmail($email)
# Returns whether $email is a valid email address.
function checkEmail($email) {
  return preg_match("/([\w\.\-]+)(\@[\w\.\-]+)(\.[a-z]{2,4})+/i", $email);
}

# function checkUrl($url)
# Returns whether $url is a valid url address.
function checkUrl($url) {
  return preg_match("#^http://[_a-z0-9-]+\\.[_a-z0-9-]+#i", $url);
}

# function newPostNotify($user)
# Lets the admin know (by mail) that $user has added a new entry to
# the guestbook. It will work only if mail() function is available
# on the server (some free PHP hosting servers disallow this function
# in order to avoid spamming).
function newPostNotify($name, $email, $url, $message) {
  global $gbNotifyFrom, $gbNotifyTo, $gbNotifyTitle, $gbNotifyText;

  $emailContent = $gbNotifyText;
  # Replacing entry GB_TAGS (note that date can not be used here).
  $emailContent = str_replace("<!--GB_ENTRYNAME-->", $name, $emailContent);
  $emailContent = str_replace("<!--GB_ENTRYEMAIL-->", $email, $emailContent);
  $emailContent = str_replace("<!--GB_ENTRYURL-->", $url, $emailContent);
  $emailContent = str_replace("<!--GB_ENTRYMESSAGE-->", $message, $emailContent);

  # Swapping global GB_TAGS.
  $emailContent = swapGlobalTags($emailContent);

  # Send the notify email, it will work only if the PHP function mail()
  # is available. If it is not, you can disable the notify option by setting
  # $gbNewPostNotify variable to 0 in config.php
  mail($gbNotifyTo, $gbNotifyTitle, $emailContent, "From: " . $gbNotifyFrom) or die("mail() function is not available!");
}

# function cleanField($string)
# This function cleans not desired stuff from $string.
# It is used to adequate name, email and url fields when
# adding a new entry to YapGB.
function cleanField($string) {
  $string = trim($string);
  # Now htmlspecialchars() is used instead of strip_tags().
  $string = htmlspecialchars($string);
  $string = str_replace("|", "&brvbar;", $string);

  if ( get_magic_quotes_gpc() )
    $string = stripslashes($string);

  return $string;
}

# function cleanMessage($string)
# Similar to cleanField($string), but this one is used
# to adequate the message field since it needs a different
# 'treatment' ;).
function cleanMessage($string) {
  global $gbAllowedTags;
  $string = trim($string);
  //$string = htmlspecialchars($string);
  $string = strip_tags($string, $gbAllowedTags);
  $string = str_replace("|", "&brvbar;", $string);
  $string = str_replace("\n", "<br>", $string);
  $string = str_replace("\r", "", $string);

  if ( get_magic_quotes_gpc() )
    $string = stripslashes($string);

  return $string;
}

# function readTemplate($templateFile)
# This function returns a string with the content
# of $templateFile.
# Now it gets only the file name as parameter, not the full path.
function readTemplate($templateFile) {
  global $gbTheme;

  // Check whether $templateFile exists in the current theme folder,
  // if not, use melody1 instead. melody1 is recommended to be
  // available always.
  if ( file_exists("themes/$gbTheme/$templateFile") )
    $templateFile = "themes/$gbTheme/$templateFile";
  else
    $templateFile = "themes/melody1/$templateFile";

  $fp = fopen($templateFile, "r");
  fseek($fp, 0);
  $templateData = fread($fp, filesize($templateFile));
  fclose($fp);

  return $templateData;
}

# function swapPaginTags
# Creates the pagination links and replaces them for the
# <!--GB_PAGINATION--> gb_tag in $string.
function swapPaginTags($string, $totalEntries, $pageCurrent) {
  global $gbIndex, $gbLimit;
  global $msgNext, $msgPrev;

  # I've changed pagination algorithm a bit,
  # it is not commented, make sure to understand
  # it if you're planning to edit it.
  # Please let me know if you know of a better way for
  # managing pagination links.

  if ($pageCurrent != 1) {
    $pagePrev = $pageCurrent - 1;
    $pagination = "<a href=\"$gbIndex?page=$pagePrev\" class=\"pagin\">$msgPrev</a>&nbsp;";
  }
  else {
    $pagination = "$msgPrev&nbsp;";
  }

  /*
  $numOfPages = $totalEntries / $gbLimit;
  $lastPage = ceil($numOfPages);
  $pageLimit = 10;
  */
  /* CORRECTION: the final number in $numOfPages was being omitted,
   * the if condition below makes it work correctly.
   * Thanks to Dan Edwards for the correction :).
   */
  if ($totalEntries > $gbLimit and ($totalEntries % $gbLimit) != 0) {
    $numOfPages = ($totalEntries+$gbLimit) / $gbLimit;
  }
  else {
    $numOfPages = ($totalEntries) / $gbLimit;
  }
  $lastPage = ceil($numOfPages);
  $pageLimit = 10;


  if ($pageCurrent > 10) {
    $startPage = $pageCurrent - 10;
    $endPage = $startPage + $pageLimit;
    if ($startPage != 1)
      $pagination .= "<a href=\"$gbIndex?page=1\" class=\"pagin\">1</a>&nbsp;..&nbsp;";
  }
  else {
    $startPage = 1;
    $endPage = $pageLimit;
  }

  for ($i = $startPage; $i <= $endPage and $i <= $numOfPages; $i++) {
    if ($i == $pageCurrent)
        $pagination .= "<b>$i</b>&nbsp;";
    else {
        $pagination .= "<a href=\"$gbIndex?page=$i\" class=\"pagin\">$i</a>&nbsp;";
    }
  }

  if ($pageCurrent < $lastPage and $lastPage > 10)
    $pagination .= "..&nbsp;<a href=\"$gbIndex?page=$lastPage\" class=\"pagin\">$lastPage</a>&nbsp;";
  else {
    if ($lastPage > 10)
      $pagination .= "<b>$lastPage</b>&nbsp;";
  }

  if ( ($totalEntries - ($gbLimit * $pageCurrent)) > 0 ) {
    $pageNext = $pageCurrent + 1;
    $pagination .= "<a href=\"$gbIndex?page=$pageNext\" class=\"pagin\">$msgNext</a>&nbsp;";
  }
  else
    $pagination .= "$msgNext ";

  $paginationInfo = "Showing ".$limitValue." to ".$gbLimit*$page." from a total of ".$totalEntries;

  $string = str_replace("<!--GB_PAGINATION-->", $pagination, $string);

  return $string;
}

# function swapGlobalTags($string)
# It replaces global GB_TAGs found in $string.
# Global gb_tags are taken from variables defined in config.php.
function swapGlobalTags($string) {
  global $gbTitle, $gbIndex, $gbSiteIndex, $gbAllowedHTMLTags, $gbInfo;

  $allowedTags = $gbAllowedHTMLTags == "" ? " none." : $gbAllowedHTMLTags;


  $string = str_replace("<!--GB_TITLE-->", $gbTitle, $string);
  $string = str_replace("<!--GB_INDEX-->", $gbIndex, $string);
  $string = str_replace("<!--GB_SITEINDEX-->", $gbSiteIndex, $string);
  $string = str_replace("<!--GB_ALLOWEDTAGS-->", htmlspecialchars($allowedTags), $string);
  $string = str_replace("<!--GB_INFO-->", $gbInfo, $string);

  return $string;
}

# function swapEntryTags($string)
# This returns a string with entry GB_TAGs substituted.
function swapEntryTags($string, $id, $name, $date, $email, $url, $message) {
  $string = str_replace("<!--GB_ENTRYID-->", $id, $string);
  $string = str_replace("<!--GB_ENTRYNAME-->", $name, $string);
  $string = str_replace("<!--GB_ENTRYEMAIL-->", $email, $string);
  $string = str_replace("<!--GB_ENTRYURL-->", $url, $string);
  $string = str_replace("<!--GB_ENTRYMESSAGE-->", $message, $string);
  $string = swapDateTags($string, $date);

  return $string;
}

# function swapDateTags($string, $date)
# Replaces GB_TAGs related to the date of the entry.
function swapDateTags($string, $date) {
  global $gbGMTOffset;

  // Changed it before setting the time offset since it needs to
  // keep unchanged.
  $string = str_replace("<!--GB_ENTRYDATEINT-->", $date, $string);

  $timeOffset = 3600 * $gbGMTOffset;
  $date += $timeOffset;

  $string = str_replace("<!--GB_ENTRYDAY-->", gmstrftime("%a", $date), $string);
  $string = str_replace("<!--GB_ENTRYDAYN-->", gmstrftime("%d", $date), $string);
  $string = str_replace("<!--GB_ENTRYMONTH-->", gmstrftime("%b", $date), $string);
  $string = str_replace("<!--GB_ENTRYMONTHN-->", gmstrftime("%m", $date), $string);
  $string = str_replace("<!--GB_ENTRYYEAR-->", gmstrftime("%y", $date), $string);
  $string = str_replace("<!--GB_ENTRYTIME-->", gmstrftime("%X", $date), $string);
  $string = str_replace("<!--GB_ENTRYDATEFULL-->", gmstrftime("%c", $date), $string);

  # New date GB_TAGS
  $string = str_replace("<!--GB_ENTRYDAYFULL-->", gmstrftime("%A", $date), $string);
  $string = str_replace("<!--GB_ENTRYMONTHFULL-->", gmstrftime("%B", $date), $string);
  $string = str_replace("<!--GB_ENTRYYEARFULL-->", gmstrftime("%Y", $date), $string);

  return $string;
}

# function swapBBCode($string)
# I'm planning on deprecating the use of HTML tags within messages and
# using BBcode tags instead. But not yet.
# Currently available tags:
# - bold, italics and underlined text.
# - images within messages.
# - url and email links
function swapBBCode($string) {
  // Bold, italics and underlined text.
  $string = preg_replace("/(\[b\])(.+?)(\[\/b\])/i", "<b>\\2</b>", $string);
  $string = preg_replace("/(\[i\])(.+?)(\[\/i\])/i", "<i>\\2</i>", $string);
  $string = preg_replace("/(\[u\])(.+?)(\[\/u\])/i", "<u>\\2</u>", $string);

  // Images
  //$string = preg_replace("/(\[img\])(.+?)(\[\/img\])/i", '<img src="\\2" alt="\\2">', $string);

  // Email links
  $string = preg_replace("/(\[email\])(.+?)(\[\/email\])/i", '<a href="mailto:\\2">\\2</a>', $string);
  $string = preg_replace("/(\[email=(.+?)\])(.+?)(\[\/email\])/i", '<a href="mailto:\\2">\\3</a>', $string);

  $string = preg_replace("/(\[url\])(.+?)(\[\/url\])/i", '<a href="\\2" target="_blank">\\2</a>', $string);
  $string = preg_replace("/(\[url=\])(.+?)(\[\/url\])/i", '<a href="\\2" target="_blank">\\2</a>', $string);
  $string = preg_replace("/(\[url=(.+?)\])(.+?)(\[\/url\])/i", '<a href="\\2" target="_blank">\\3</a>', $string);

  return $string;
}

# function swapSmilies($string)
# This function will swap smilies such as :), :P, :(, etc. for
# a corresponding image indicated by the $gbSmilies array in
# config.php.
# Images are stored into a smilies/ folder.
function swapSmilies($string) {
  global $gbSmilies, $gbSmiliesPath;

  while ( list($emoticon, $data) = each($gbSmilies) ) {
    $imgTag = "<img src=\"" . $gbSmiliesPath . $data[0] . "\" alt=\"$data[1]\" title=\"$data[1]\" border=\"0\">";
    $string = str_replace($emoticon, $imgTag, $string);
  }
  reset($gbSmilies);

  return $string;
}

?>